<?php

function al_add_settings_page() {
    add_options_page( 'Aulands', 'Aulands', 'manage_options', 'aulands-plugin-menu', 'al_render_plugin_settings_page' );
}
add_action( 'admin_menu', 'al_add_settings_page' );

function al_render_plugin_settings_page() {
    ?>
    <h2>Ajustes de Aulands WooCommerce</h2>
    <form action="options.php" method="post">
      <?php
        settings_fields( 'aulands_plugin_options' );
        do_settings_sections( 'aulands_plugin' );
      ?>
      <input name="submit" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save' ); ?>" />
    </form>
    <?php
}

function al_register_settings() {
  register_setting( 'aulands_plugin_options', 'aulands_plugin_options', 'aulands_plugin_options_validate' );
  add_settings_section( 'api_settings', 'API Settings', 'al_plugin_section_text', 'aulands_plugin' );
  add_settings_field( 'al_plugin_setting_api_key', 'API Key', 'al_plugin_setting_api_key', 'aulands_plugin', 'api_settings' );
}
add_action( 'admin_init', 'al_register_settings' );

function aulands_plugin_options_validate( $input ) {
  $input['api_key'] = encrypt($input['api_key']);
  return $input;
}

function al_plugin_section_text() {
?>
  <h3>¿Cómo obtener mi clave API de Aulands?</h3>
  <ol>
    <li>Accede a <a href="https://app.aulands.com/admin">Aulands como director</a></li>
    <li>Busca tu aula</li>
    <li>En la pestaña <i>Info</i>, la primera que se muestra por defecto, encontrarás tu clave API debajo del campo <i>Descripción</i></li>
  </ol>
  <p>Si tienes problemas para encontrar tu clave API, ponte en contacto con nosotros en <a href="mailto:soporte@aulands.com">soporte@aulands.com</a>.</p>
<?php
}

function al_plugin_setting_api_key() {
  $options = get_option( 'aulands_plugin_options' );
  echo "<input id='al_plugin_setting_api_key' name='aulands_plugin_options[api_key]' type='text' value='".decrypt($options['api_key'])."' />";

  if($options['api_key']){
    $key = decrypt($options['api_key']);
    $args = array(
      'headers' => array(
        'Content-Type' => 'application/json',
        'Authorization' => $key
      )
    );
    $llamada = wp_remote_get( 'https://api.aulands.com/classroom', $args );

    if (is_wp_error($llamada) || empty($llamada['response']) || $llamada['response']['code'] == '400') {
      echo '<p style="color:red">Ha habido un error. Inténtalo de nuevo o ponte en contacto con Aulands.<p>';
    }else{
      $body = wp_remote_retrieve_body( $llamada );
      $body = json_decode($body);

      if($body->name) echo '<p style="color:green">clave API correcta para el aula: '.$body->name.'<p>';
      else echo '<p style="color:red">La clave API no es correcta<p>';
    }
  
  }
}

function al_plugin_setting_results_limit() {
  $options = get_option( 'aulands_plugin_options' );
  echo "<input id='al_plugin_setting_results_limit' name='aulands_plugin_options[results_limit]' type='text' value='".$options['results_limit']."' />";
}
